/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT
 * Although most of the following code is written from scratch, it is
 * heavily influenced by Q (https://github.com/kriskowal/q) and uses some of Q's spec.
 */
!function(e){if("object"==typeof module&&"object"==typeof module.exports){var t=e(require,exports);void 0!==t&&(module.exports=t)}else"function"==typeof define&&define.amd&&define(["require","exports","../Types","../Threading/deferImmediate","../Disposable/DisposableBase","../Exceptions/InvalidOperationException","../Exceptions/ArgumentException","../Exceptions/ArgumentNullException","../Disposable/ObjectPool","../Collections/Set","../Threading/defer","../Disposable/ObjectDisposedException","../../extends"],e)}(function(e,t){"use strict";function n(e){return u["default"].hasMemberOfType(e,S,u["default"].FUNCTION)}function r(e,t,r){var i=t?t(e):e;return i&&n(i)?F.wrap(i):r(i)}function i(e,t,n){try{var r=n?n(t):t;e&&e.resolve(r)}catch(i){e.reject(i)}}function o(e,t,n,r){try{var i=r?r(n):n;e&&e(i)}catch(o){t&&t(o)}}function s(e,t,n){e instanceof x?e.thenThis(t,n):e.then(t,n)}function l(){return new w.ObjectDisposedException("Promise","An underlying promise-result was disposed.")}var u=e("../Types"),a=e("../Threading/deferImmediate"),c=e("../Disposable/DisposableBase"),f=e("../Exceptions/InvalidOperationException"),h=e("../Exceptions/ArgumentException"),p=e("../Exceptions/ArgumentNullException"),d=e("../Disposable/ObjectPool"),v=e("../Collections/Set"),g=e("../Threading/defer"),w=e("../Disposable/ObjectDisposedException"),y=e("../../extends"),_=y["default"],m=void 0,b="Promise",j=b+"State",S="then",I="target",D=function(e){function t(t,n,r){e.call(this),this._state=t,this._result=n,this._error=r,this._disposableObjectName=j}return _(t,e),t.prototype._onDispose=function(){this._state=m,this._result=m,this._error=m},t.prototype.getState=function(){return this._state},Object.defineProperty(t.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isPending",{get:function(){return this.getState()===F.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isSettled",{get:function(){return this.getState()!=F.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isFulfilled",{get:function(){return this.getState()===F.State.Fulfilled},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isRejected",{get:function(){return this.getState()===F.State.Rejected},enumerable:!0,configurable:!0}),t.prototype.getResult=function(){return this._result},Object.defineProperty(t.prototype,"result",{get:function(){return this.throwIfDisposed(),this.getResult()},enumerable:!0,configurable:!0}),t.prototype.getError=function(){return this._error},Object.defineProperty(t.prototype,"error",{get:function(){return this.throwIfDisposed(),this.getError()},enumerable:!0,configurable:!0}),t}(c.DisposableBase);t.PromiseState=D;var x=function(e){function t(){e.call(this,F.State.Pending),this._disposableObjectName=b}return _(t,e),t.prototype.then=function(e,t){var n=this;return new F(function(r,i){n.thenThis(function(t){return o(r,i,t,e)},function(e){return t?o(r,null,e,t):i(e)})})},t.prototype.done=function(e,t){var n=this;g.defer(function(){return n.thenThis(e,t)})},t.prototype.delayFromNow=function(e){var t=this;return void 0===e&&(e=0),this.throwIfDisposed(),new F(function(n,r){g.defer(function(){t.thenThis(function(e){return n(e)},function(e){return r(e)})},e)},!0)},t.prototype.delayAfterResolve=function(e){var t=this;return void 0===e&&(e=0),this.throwIfDisposed(),this.isSettled?this.delayFromNow(e):new F(function(n,r){t.thenThis(function(t){return g.defer(function(){return n(t)},e)},function(t){return g.defer(function(){return r(t)},e)})},!0)},t.prototype["catch"]=function(e){return this.throwIfDisposed(),this.then(m,e)},t.prototype["finally"]=function(e){return this.throwIfDisposed(),this.then(e,e)},t.prototype.finallyThis=function(e){this.throwIfDisposed();var t=function(){return a.deferImmediate(e)};return this.thenThis(t,t),this},t}(D);t.PromiseBase=x;var E=function(e){function t(){e.apply(this,arguments)}return _(t,e),t.prototype.thenSynchronous=function(e,t){this.throwIfDisposed();try{switch(this.state){case F.State.Fulfilled:return e?r(this._result,e,F.resolve):this;case F.State.Rejected:return t?r(this._error,t,F.resolve):this}}catch(n){return new R(n)}throw new Error("Invalid state for a resolved promise.")},t.prototype.thenThis=function(e,t){switch(this.throwIfDisposed(),this.state){case F.State.Fulfilled:e&&e(this._result);break;case F.State.Rejected:t&&t(this._error)}return this},t}(x);t.Resolvable=E;var P=function(e){function t(t,n,r){e.call(this),this._result=n,this._error=r,this._state=t}return _(t,e),t}(E);t.Resolved=P;var O=function(e){function t(t){e.call(this,F.State.Fulfilled,t)}return _(t,e),t}(P),R=function(e){function t(t){e.call(this,F.State.Rejected,m,t)}return _(t,e),t}(P),A=function(e){function t(t){var r=this;if(e.call(this),this._target=t,!t)throw new p.ArgumentNullException(I);if(!n(t))throw new h.ArgumentException(I,"Must be a promise-like object.");t.then(function(e){r._state=F.State.Fulfilled,r._result=e,r._error=m,r._target=m},function(e){r._state=F.State.Rejected,r._error=e,r._target=m})}return _(t,e),t.prototype.thenSynchronous=function(t,n){this.throwIfDisposed();var r=this._target;return r?new F(function(e,i){s(r,function(n){return o(e,i,n,t)},function(t){return n?o(e,null,t,n):i(t)})},!0):e.prototype.thenSynchronous.call(this,t,n)},t.prototype.thenThis=function(t,n){this.throwIfDisposed();var r=this._target;return r?(s(r,t,n),this):e.prototype.thenThis.call(this,t,n)},t.prototype._onDispose=function(){e.prototype._onDispose.call(this),this._target=m},t}(E),F=function(e){function t(t,n){void 0===n&&(n=!1),e.call(this),t&&this.resolveUsing(t,n)}return _(t,e),t.prototype.thenSynchronous=function(n,r){if(this.throwIfDisposed(),this._state)return e.prototype.thenSynchronous.call(this,n,r);var i=new t;return(this._waiting||(this._waiting=[])).push(T.PromiseCallbacks.init(n,r,i)),i},t.prototype.thenThis=function(t,n){return this.throwIfDisposed(),this._state?e.prototype.thenThis.call(this,t,n):((this._waiting||(this._waiting=[])).push(T.PromiseCallbacks.init(t,n)),this)},t.prototype._onDispose=function(){e.prototype._onDispose.call(this),this._resolvedCalled=m},t.prototype.resolveUsing=function(e,n,r){var i=this;if(void 0===n&&(n=!1),void 0===r&&(r=!1),!e)throw new p.ArgumentNullException("resolver");if(this._resolvedCalled)throw new f.InvalidOperationException(".resolve() already called.");if(this.state)throw new f.InvalidOperationException("Already resolved: "+t.State[this.state]);this._resolvedCalled=!0;var o=0,s=function(e){o?console.warn(-1==o?"Rejection called multiple times":"Rejection called after fulfilled."):(o=-1,i._resolvedCalled=!1,i.reject(e))},l=function(e){o?console.warn(1==o?"Fulfill called multiple times":"Fulfill called after rejection."):(o=1,i._resolvedCalled=!1,i.resolve(e))};n?e(l,s):a.deferImmediate(function(){return e(l,s)})},t.prototype._emitDisposalRejection=function(e){var t=e.wasDisposed;return t&&this._rejectInternal(l()),t},t.prototype._resolveInternal=function(e){var r=this;if(!this.wasDisposed){for(;e instanceof x;){var o=e;if(this._emitDisposalRejection(o))return;switch(o.state){case t.State.Pending:return void o.thenSynchronous(function(e){return r._resolveInternal(e)},function(e){return r._rejectInternal(e)});case t.State.Rejected:return void this._rejectInternal(o.error);case t.State.Fulfilled:e=o.result}}if(n(e))e.then(function(e){return r._resolveInternal(e)},function(e){return r._rejectInternal(e)});else{this._state=t.State.Fulfilled,this._result=e,this._error=m;var s=this._waiting;if(s){this._waiting=m;for(var l=0,u=s;l<u.length;l++){var a=u[l],c=a.onFulfilled,f=a.promise,h=f;T.PromiseCallbacks.recycle(a),i(h,e,c)}s.length=0}}}},t.prototype._rejectInternal=function(e){if(!this.wasDisposed){this._state=t.State.Rejected,this._error=e;var n=this._waiting;if(n){this._waiting=null;for(var r=0,o=n;r<o.length;r++){var s=o[r],l=s.onRejected,u=s.promise,a=u;T.PromiseCallbacks.recycle(s),l?i(a,e,l):a.reject(e)}n.length=0}}},t.prototype.resolve=function(e,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),e==this)throw new f.InvalidOperationException("Cannot resolve a promise as itself.");if(this._state){if(!n||this._state==t.State.Fulfilled&&this._result===e)return;throw new f.InvalidOperationException("Changing the fulfilled state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new f.InvalidOperationException(".resolve() already called.")}else this._resolveInternal(e)},t.prototype.reject=function(e,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),this._state){if(!n||this._state==t.State.Rejected&&this._error===e)return;throw new f.InvalidOperationException("Changing the rejected state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new f.InvalidOperationException(".resolve() already called.")}else this._rejectInternal(e)},t}(E);t.Promise=F;var T;!function(e){var t;!function(e){function t(){return o||(o=new d.ObjectPool(40,n,function(e){e.onFulfilled=null,e.onRejected=null,e.promise=null}))}function n(){return{onFulfilled:null,onRejected:null,promise:null}}function r(e,n,r){var i=t().take();return i.onFulfilled=e,i.onRejected=n,i.promise=r,i}function i(e){t().add(e)}var o;e.init=r,e.recycle=i}(t=e.PromiseCallbacks||(e.PromiseCallbacks={}))}(T||(T={}));var F;!function(e){function t(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];if(!t&&!n.length)throw new p.ArgumentNullException("promises");var i=(Array.isArray(t)?t:[t]).concat(n);return!i.length||i.every(function(e){return!e})?new O(i):new e(function(e,t){var n=[],r=i.length;n.length=r;for(var o=new v.Set(i.map(function(e,t){return t})),s=function(){t=null,e=null,i.length=0,i=null,o.dispose(),o=null},l=function(){var t=e;t&&!o.count&&(s(),t(n))},u=function(t,r){e&&(n[r]=t,o.remove(r),l())},a=function(e){var n=t;n&&(s(),n(e))},c=function(e){var t=i[e];t?t.then(function(t){return u(t,e)},a):o.remove(e),l()},f=0;o&&r>f;f++)c(f)})}function r(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];if(!t&&!n.length)throw new p.ArgumentNullException("promises");var i=(Array.isArray(t)?t:[t]).concat(n);return!i.length||i.every(function(e){return!e})?new O(i):new e(function(e,t){for(var n=i.length,r=new v.Set(i.map(function(e,t){return t})),o=function(){t=null,e=null,r.dispose(),r=null},s=function(){var t=e;t&&!r.count&&(o(),t(i))},l=function(e){r&&(r.remove(e),s())},u=function(e){var t=i[e];t?t.then(function(t){return l(e)},function(t){return l(e)}):l(e)},a=0;r&&n>a;a++)u(a)})}function i(t){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];var i=t&&(Array.isArray(t)?t:[t]).concat(n);if(!i||!i.length||!(i=i.filter(function(e){return null!=e})).length)throw new h.ArgumentException("Nothing to wait for.");var o=i.length;if(1==o)return l(i[0]);for(var s=0;o>s;s++){var u=i[s];if(u instanceof x&&u.isSettled)return u}return new e(function(e,t){for(var n=function(){t=null,e=null,i.length=0,i=null},r=function(e,t){e&&(n(),e(t))},o=function(t){return r(e,t)},s=function(e){return r(t,e)},l=0,u=i;l<u.length;l++){var a=u[l];if(!e)break;a.then(o,s)}})}function o(e){return n(e)?l(e):new O(e)}function s(e){return new R(e)}function l(e){if(!e)throw new p.ArgumentNullException(I);return e instanceof x?e:new A(e)}function u(e){if(!e)throw new p.ArgumentNullException(S);return new A({then:e})}!function(e){e[e.Pending=0]="Pending",e[e.Fulfilled=1]="Fulfilled",e[e.Rejected=-1]="Rejected"}(e.State||(e.State={}));var a=e.State;Object.freeze(a),e.all=t,e.waitAll=r,e.race=i,e.resolve=o,e.reject=s,e.wrap=l,e.createFrom=u}(F=t.Promise||(t.Promise={}))});
//# sourceMappingURL=Promise.js.map
